9H	LOC	8B			// CODE

	PREFIX	__std_lib_stuff:

:putchar	IS	@
	STB	$0,:__sp,0
	STOU	:__sp,:__sp,8
	SET	$1,1
	STOU	$1,:__sp,16
	LDA	$255,:__sp,8
	TRAP	0,:Fwrite,:StdOut
	SET	$0,$255
	POP	1,0

:exit	IS	@
	TRAP	0,:Halt,0

:printf	IS	@
	// prepare frame
	STOU	:__fp,:__sp,56
	SET	:__fp,:__sp
	ADDU	:__sp,:__sp,248 // need 72 for args, amap for %d
	GET	$255,:rJ
	STOU	$255,:__fp,64	
	
	// store arguments
	STOU	$7,:__fp,0
	STOU	$6,:__fp,8
	STOU	$5,:__fp,16
	STOU	$4,:__fp,24
	STOU	$3,:__fp,32
	STOU	$2,:__fp,40
	STOU	$1,:__fp,48

	// prepare some stuff 
	LDA	$8,:__fp,48	// the substitutes
	SETL	$9,0		// the counter for the org string
	SETL	$10,0		// the counter for outputted string

	// Now process input
loop	IS	@
	SET	$15,4
	LDB	$20,$0,$9
	CMP	$11,$20,0
	BZ	$11,end
	CMP	$11,$20,'%'
	BNZ	$11,out

again	IS	@
	// we found a '%', now see what it wants
	ADDU	$9,$9,1
	LDB	$20,$0,$9
	CMP	$11,$20,'c'
	BZ	$11,found_c
	CMP	$11,$20,'d'
	BZ	$11,found_d
	CMP	$11,$20,'x'
	BZ	$11,found_x
	CMP	$11,$20,'s'
	BZ	$11,found_s
	CMP	$11,$20,'l'
	BZ	$11,found_l
	CMP	$11,$20,'0'
	BN	$11,error
	CMP	$11,$20,'9'
	BN	$11,again
	JMP	error

// %c

found_c	IS	@
	LDB	$20,$8,7
	SUBU	$8,$8,8
	JMP	out

// %d and %x

found_l		IS	@
	SET	$15,0	// offset to load from
	JMP	again

lookup_dx	IS	@
	BYTE	'0','1','2','3','4','5','6','7','8','9'
	BYTE	'a','b','c','d','e','f'

found_d	IS	@
	SET	$18,10		// divider
	JMP	found_dx

found_x	IS	@
	SET	$18,16
	JMP	found_dx

found_dx	IS	@
	// initialize lookup buffer
	GETA	$17,lookup_dx	// lookup for hex

	// initialize buffer and write trailing \0
	ADDU	$12,:__fp,247
	SET	$13,0
	STB	$13,$12
	SUBU	$12,$12,1

	// load the number to crunch
	CMP	$11,$15,0
	BZ	$11,load_octa
	LDT	$13,$8,4
	JMP	done_loading
load_octa	IS	@
	LDO	$13,$8,0
done_loading	IS	@
	SUBU	$8,$8,8
	
	// check if negative and store that
	XOR	$16,$16,$16	// store if negative
	CMP	$11,$13,0
	BNN	$11,not_negative
	SET	$16,1
	NEG	$13,0,$13
not_negative	IS	@
	CMP	$11,$13,0
	BNZ	$11,d_loop
	SET	$13,'0'
	STB	$13,$12
	SUBU	$12,$12,1
	JMP	d_done

	// now div and save characters
d_loop	IS	@
	CMP	$11,$13,0
	BZ	$11,d_done
	DIV	$13,$13,$18
	GET	$14,:rR
	LDB	$14,$17,$14
	STB	$14,$12
	SUBU	$12,$12,1
	JMP	d_loop

d_done	IS	@
	// add the minus sign if negative and not hex
	CMP	$11,$18,16
	BZ	$11,no_minus
	CMP	$11,$16,0
	BZ	$11,no_minus
	SET	$14,'-'
	STB	$14,$12
	SUBU	$12,$12,1
no_minus	IS	@
	// output the string 	
	ADDU	$20,$12,1
	PUSHJ	$19,:printf
	CMP	$11,$19,0
	BN	$11,error
	ADDU	$9,$9,1
	ADDU	$10,$10,$19
	JMP	loop

// %s

found_s	IS	@
	LDOU	$20,$8,7
	SUBU	$8,$8,8
	PUSHJ	$19,:printf
	CMP	$11,$19,0
	BN	$11,error
	ADDU	$9,$9,1
	ADDU	$10,$10,$19
	JMP	loop

// end %

out	IS	@
	PUSHJ	$19,:putchar
	CMP	$11,$19,0
	BNZ	$11,error
	ADDU	$9,$9,1
	ADDU	$10,$10,1
	JMP	loop

error	IS	@
	// return a negative value, negative count -1
	SET	$1,0
	SUBU	$10,$1,$10
	SUBU	$10,$10,1

end	IS	@	
	SET	$0,$10
	LDOU	$255,:__fp,64
	PUT	:rJ,$255
	SUBU	:__sp,:__sp,248
	LDOU	:__fp,:__sp,56
	POP	1,0

8H	LOC	9B			// DATA

	PREFIX	:



