/*
 * memory.h -- simulation of physical address space
 */


#ifndef _MEMORY_H_
#define _MEMORY_H_


octa memoryRead(octa addr);
void memoryWrite(octa addr, octa data);

U32 memoryGetSize(void);

void memoryReset(void);
void memoryInit(U32 memorySize, char *romName, char *progName);
void memoryExit(void);


#endif /* _MEMORY_H_ */
