%
% rom01.mms -- terminal output, polled
%

	LOC	#8000800000000000

Main	SETH	$0,#8001	% set terminal base address
1H	SETL	$2,#0061	% set char to ASCII 'a'
2H	SYNC	0		% drain pipeline
	LDOU	$1,$0,16	% load status word into $1
	AND	$1,$1,#1	% extract LSB - 'transmitter ready'
	BZ	$1,2B		% loop while not ready
	STOU	$2,$0,24	% store char into transmitter data register
	SYNCD	7,$0,24		% empty write buffer
	ADDU	$2,$2,1		% next char
	CMP	$1,$2,#7B	% check if above 'z'
	BNZ	$1,2B		% no - loop
	JMP	1B		% else reset to 'a'
